<?php

defined('_JEXEC') or die('Restricted access');

class plgJshoppingRouterJshopping_product_seo extends JPlugin {

    public $query = array();
    public $segments = array();

    function __construct(& $subject, $config) {
        parent::__construct($subject, $config);
    }

    function onBeforeBuildRoute(&$query, &$segments) {
        $this->query = $query;
        $this->segments = $segments;
    }

    function onAfterBuildRoute(&$query, &$segments) {		
        if (isset($this->query['controller'])) {
            $controller = $this->query['controller'];
        } else {
            $controller = "";
        }
        $lang = isset($query['lang']) ? $query['lang'] : '';
        if ( $controller == "product" && $this->query['task'] == "view" && $this->query['category_id'] && $this->query['product_id']) {
            $prodalias = \JSFactory::getAliasProduct($lang);			
            $shim = \Joomla\Component\Jshopping\Site\Lib\ShopItemMenu::getInstance($lang);
            $categoryitemidlist = $shim->getListCategory();			
            if ((isset($categoryitemidlist[$this->query['category_id']]) && $categoryitemidlist[$this->query['category_id']] && isset($prodalias[$this->query['product_id']])) || (isset($prodalias[$this->query['product_id']]))) {
                $segments = $this->segments;
                $segments[] = $prodalias[$this->query['product_id']];
            }
        }
    }

    function onBeforeParseRoute(&$vars, &$segments) {
        if ( $this->_checkJSCategoryCurentMenuItem() ) {
            return NULL;
        }
        $prodalias = \JSFactory::getAliasProduct();
        $segments[0] = \JSHelper::getSeoSegment($segments[0]);
		$s1 = $segments[1] ?? null;
        if ($segments[0] && !$s1 && in_array($segments[0], $prodalias)) {
            $this->segments = $segments;
            $segments[0] = 'content';
			$segments[1] = '';
			$segments[2] = '';
        }
    }

    function onAfterParseRoute(&$vars, &$segments) {
        if (is_array($this->segments) && count($this->segments) && ($segments[0] == 'content' && $segments[1] == '')) {
            $vars = array();
            $prodalias = \JSFactory::getAliasProduct();
            $product_id = array_search($this->segments[0], $prodalias, true);
            if (!$product_id) {
                \JSError::raiseError(404, \JText::_('JSHOP_PAGE_NOT_FOUND'));
            }
            $vars['controller'] = "product";
            $vars['task'] = "view";
            $product = \JSFactory::getTable('product', 'jshop');
            $product->load($product_id);
            $vars['category_id'] = $product->getCategory();
            $vars['product_id'] = $product_id;
        }
    }

    function _checkJSCategoryCurentMenuItem() {
        $menu = \JFactory::getApplication()->getMenu();
        $menuItem = $menu->getActive();
        $link = $menuItem->query;
        if (
			$link["option"] == "com_jshopping"
            && ((isset($link["controller"]) && $link["controller"] == "category") || (isset($link["view"]) && $link["view"] == "category"))
            && (isset($link["category_id"]) && intval($link["category_id"]) > 0)) {
				return TRUE;
        }
    }

}